SU(1)

NAME
su - change user ID or become super-user

SYNOPSIS

su [options] [LOGIN]

DESCRIPTION

su is used to become another user during a login session. Invoked without a username, su defaults to becoming the super user. The optional argument - may be used to provide an environment similar to what the user would expect had the user logged in directly.

Additional arguments may be provided after the username, in which case they are supplied to the user's login shell. In particular, an argument of -c will cause the next argument to be treated as a command by most command interpreters. The command will be executed by the shell specified in /etc/passwd for the target user.

You can use the -- argument to separate su options from the arguments supplied to the shell.

The user will be prompted for a password, if appropriate. Invalid passwords will produce an error message. All attempts, both valid and invalid, are logged to detect abuse of the system.

The current environment is passed to the new shell. The value of $PATH is reset to /bin:/usr/bin for normal users, or /sbin:/bin:/usr/sbin:/usr/bin for the super user. This may be changed with the ENV_PATH and ENV_SUPATH definitions in /etc/login.defs.

A subsystem login is indicated by the presence of a "*" as the first character of the login shell. The given home directory will be used as the root of a new file system which the user is actually logged into.

OPTIONS

The options which apply to the su command are:

-c, --command SHELL
    Specify a command that will be invoked by the shell using its -c.

-, -l, --login
    Provide an environment similar to what the user would expect had the user logged in directly.

    When - is used, it must be specified as the last su option. The other forms (-l and --login) do not have this restriction.

-s, --shell SHELL
    The shell that will be invoked.

    The invoked shell is choosen among (higest priority first):

    •   The shell specified with --shell

    •   If --preserve-environment is used, the shell specified by the $SHELL environment variable.

    •   The shell indicated in the /etc/passwd entry for the target user.

    •   /bin/sh if a shell could not be found by any above method.

    If the target user has a restricted shell (i.e. the shell field of this user's entry in /etc/passwd is not specified in /etc/shell), then the --shell option or the $SHELL environment variable won't be taken into account unless su is called by the root.

-m, -p, --preserve-environment
    Preserve the current environment.

    If the target user has a restricted shell, this option has no effect (unless su is called by root).

CAVEATS

This version of su has many compilation options, only some of which may be in use at any particular site.

FILES

/etc/passwd
    User account information.

/etc/shadow
    Secure user account information.

SEE ALSO

login(1), login.defs(5), sh(1)